#ifndef __DUMP_H__
#define __DUMP_H__
#ifdef __cplusplus
extern "C" {
#endif

#include "lib/gba.h"

//---------------------------------------------------------------------------
#define DUMP_ROM_START		0x08000000
#define DUMP_ROM_END		0x0a000000


enum {
	DUMP_ACT_CALC,
	DUMP_ACT_LINK,
	DUMP_ACT_SIZE,
	DUMP_ACT_SIZE_CRC,
	DUMP_ACT_DATA,
	DUMP_ACT_DATA_CRC,
	DUMP_ACT_END,
};

//---------------------------------------------------------------------------
typedef struct {
	u32 act;

	u32 sizeCRC;
	u32 size;

	u32 SendCnt;
	u32 dataCRC;

	u32 crc;
} ST_DUMP;


//---------------------------------------------------------------------------
IWRAM_CODE void DumpInit(void);
IWRAM_CODE void DumpInitSub(void);

IWRAM_CODE void DumpExec(void);
IWRAM_CODE u32  DumpIntr(void);

IWRAM_CODE u32  DumpCrc(u32 f);
IWRAM_CODE void DumpCrcReset(void);

#ifdef __cplusplus
}
#endif
#endif
