#include "irq_arm.h"
#include "dump.h"

//---------------------------------------------------------------------------
IWRAM_CODE void IrqInit(void)
{
	REG_IME = 0;

	INT_VECTOR    = (u32)IrqHandler;
	REG_IE        = IRQ_SERIAL | IRQ_VBLANK;
	REG_SIOCNT    = SIO_IRQ | SIO_32BIT | SIO_START;
	REG_SIODATA32 = 0;
	REG_DISPSTAT  = LCDC_VBL;

	REG_IME = 1;
}
//---------------------------------------------------------------------------
IWRAM_CODE void IrqHandler(void)
{
	REG_IME  = 0;
	u16 flag = REG_IF;

	if(flag & IRQ_SERIAL)
	{
		IrqHandlerSerial();
	}

	if(flag & IRQ_VBLANK)
	{
		IrqHandlerVblank();
	}

	REG_IF  = flag;
	REG_IME = 1;
}
//---------------------------------------------------------------------------
IWRAM_CODE void IrqHandlerSerial(void)
{
	REG_SIODATA32 = DumpIntr();

	REG_SIOCNT = SIO_IRQ | SIO_32BIT | SIO_START;
}
//---------------------------------------------------------------------------
IWRAM_CODE void IrqHandlerVblank(void)
{
	// EMPTY

	REG_IRQ_WAITFLAGS |= IRQ_VBLANK;
}
